<script context="module" lang="ts">
	import { enhance } from '$lib/form';
	import type { Load } from '@sveltejs/kit';

	// see https://kit.svelte.dev/docs#loading
	export const load: Load = async ({ fetch, session, page }) => {
		const hasUserInfo = !!Object.values(session).length;
		if (hasUserInfo) {
			return {
				props: {
					userInfo: session
				}
			};
		} else {
			if (page.path == '/auth' || page.path == '/dashboard' || page.path == '/report') {
				return {};
			} else {
				return {
					status: 303,
					redirect: '/dashboard'
				};
			}
		}
	};
</script>

<script lang="ts">
	import '../app.scss';
	import { darkTheme } from 'src/stores';
	import Navigation from '$lib/components/Navigation/Navigation.svelte';
	import PageTransition from '$lib/components/PageTransition/PageTransition.svelte';

	import { goto, invalidate, prefetch, prefetchRoutes } from '$app/navigation';
	import { getStores, navigating, page, session } from '$app/stores';
	import { base, assets } from '$app/paths';
	import { onMount } from 'svelte';
	import { browser } from '$app/env';
	import Header from '$lib/components/Header/Header.svelte';
	import LoadingCircle from '$lib/utils/LoadingCircle';

	let scrollYPage;

	let timeShowPage = false;

	onMount(() => {
		const loading = new LoadingCircle();
		loading.show();
		if (
			browser &&
			userInfo &&
			Object.values(userInfo).length &&
			Object.values(userInfo['user']).length &&
			$page.path == '/auth'
		) {
			setTimeout(() => {
				goto('/dashboard');
			}, 200);
		}

		setTimeout(() => {
			timeShowPage = true;
			loading.dispose();
		}, 1000);
	});

	export let userInfo = {};
</script>

<svelte:window bind:scrollY={scrollYPage} />

<svelte:head>
	<style>
		body {
			font-family: 'Kanit';
		}
	</style>
</svelte:head>

{#if timeShowPage}
	<div class={browser && $darkTheme == true ? 'dark' : ''}>
		{#if Object.values(userInfo).length && $page.path != '/auth'}
			<div>
				{#if $page.path}
					<Header />
				{/if}
				<div>
					<PageTransition refresh={$page.path}>
						<slot />
					</PageTransition>
				</div>
			</div>
		{:else}
			<Header />
			<PageTransition refresh={$page.path}>
				<div>
					<slot />
				</div>
			</PageTransition>
		{/if}
	</div>
{/if}
